



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>shell自动补全功能：bash和zsh</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">shell自动补全功能：bash和zsh</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 13:22:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>首要一点:shell有多种，比如bash、zsh、csh、ksh、sh、tcsh等</h3>
<p>因此，制作自动补全功能时，要先搞清楚，你使用的是哪种shell，各个shell制作方法是不同的，网上大部分介绍的是关于bash的。</p>
<p>定义补全脚本后，要重新打开终端或者先执行下脚本：source</p>
<h3>一、bash：</h3>
<h4>涉及命令：</h4>
<p><strong>补全命令</strong>complete、<strong>筛选命令</strong>compgen、<strong>修改补全命令设置</strong><strong>compopt</strong></p>
<h4>内置变量：</h4>
<p>通过这些变量，可以获得当前命令的内容、位置等信息，以便判断下面应该出现的提示命令的内容</p>
<p><em>除了上面三个命令外，Bash还有几个内置变量来辅助补全功能，如下：</em></p>
<table>
<thead>
<tr>
<th>variable</th>
<th>description</th>
</tr>
</thead>
<tbody>
<tr>
<td>COMP_WORDS</td>
<td>类型为数组，存放当前命令行中输入的所有单词</td>
</tr>
<tr>
<td>COMP_CWORD</td>
<td>类型为整数，当前输入的单词在COMP_WORDS中的索引</td>
</tr>
<tr>
<td>COMPREPLY</td>
<td>类型为数组，候选的补全结果</td>
</tr>
<tr>
<td>COMP_WORDBREAKS</td>
<td>类型为字符串，表示单词之间的分隔符</td>
</tr>
<tr>
<td>COMP_LINE</td>
<td>类型为字符串，表示当前的命令行输入字符</td>
</tr>
<tr>
<td>COMP_POINT</td>
<td>类型为整数，表示光标在当前命令行的哪个位置</td>
</tr>
</tbody>
</table>
<h4>帮助信息：</h4>
<p>man complete</p>
<h4>补全脚本位置（Mac）：</h4>
<p>每打开一个新的shell，都会把这个目录下的脚本执行一遍</p>
<p>/usr/local/etc/bash_completion.d</p>
<h4>代码解读：</h4>
<div>
<pre class="prettyprint linenums">_god()<br />
{<br />
    COMPREPLY=()  # 为数组，名字必须是COMPREPLY，在给COMPREPLY赋值之前，最好将它重置清空，避免被其它补全函数干扰<br />
    local cur prev<br />
    _get_comp_words_by_ref cur prev<br />
    COMPREPLY=( $( compgen -W 'xiaomi noops blog' -- "$cur" ) )<br />
    return<br />
}<br />
complete -F _god god</pre>
</div>
<div>
<pre class="prettyprint linenums">_god()<br />
{<br />
    COMPREPLY=(xiaomi noops blog)<br />
    return<br />
}<br />
complete -F _god god</pre>
</div>
<p>查看已经有的命令补全：complete</p>
<p>最简单的使用方式：<br /><code>complete -W "192.168.1.1 192.168.1.2" ssh</code><br />这样在输入ssh 后，按tab可以提示+补全IP地址</p>
<p>参考：</p>
<p>https://mp.weixin.qq.com/s/nSje0zhcP2vAmBAH05g64w</p>
<p>http://noops.me/?p=1114</p>
<p>https://linux.cn/article-6301-1.html</p>
<h3>二、zsh：</h3>
<p>涉及命令：compctl</p>
<p>内置变量：没有bash的那些内置的变量，但是有个内置read函数，可以获取当前出现指令集、当前的指令内容、前一个指令内容等信息。</p>
<h4>帮助信息：</h4>
<p>通过这条命令查找zsh的内置函数，找到read的用法：</p>
<h4>man zshbuiltins</h4>
<p>read函数所用参数解释：</p>
<div>
<pre class="prettyprint linenums">-A     The first name is taken as the name of an array and all words are assigned to it.<br />
-n     Together with -c, the number of the word the cursor is on is read.  With -l, the index of the character the cursor is on is read.  Note that the command name is word number , not word  ,  and<br />
       that when the cursor is at the end of the line, its character index is the length of the line plus one.<br />
-c<br />
-l     These flags are allowed only if called inside a function used for completion (specified with the -K flag to compctl).  If the -c flag is given, the words of the current command are read. If the<br />
       -l flag is given, the whole line is assigned as a scalar.  If both flags are present, -l is used and -c is ignored.</pre>
</div>
<p>man zsh</p>
<h4>补全脚本位置（Mac）：每个新的shell终端都会把这个脚本执行一遍，所以内容太多，一是占用内存，而是新的terminal启动慢</h4>
<p>~/.zshrc</p>
<h4>代码解读：执行下面这段代码，终端执行proxy命令，就可以看到提示信息</h4>
<div>
<pre class="prettyprint linenums">_proxy(){<br />
    local cur cword words  # 定义变量，cur表示当前光标下的单词<br />
    read -cn cword  # 所有指令集<br />
    read -Ac words  # 当前指令的索引值<br />
    cur="$words[$cword-1]" # 当前指令值<br />
    if [ $cur = "proxy" ]  # 根据当前不同指令返回对应的提示信息<br />
    then<br />
        reply=(start stop restart connect route help)  # 必须是值reply，返回提示信息内容<br />
    elif [ $cur = "route" ]<br />
    then<br />
        reply=(add delete)<br />
    else<br />
        reply=()<br />
    fi<br />
}<br />
compctl -K _proxy proxy   # -K 表示使用函数</pre>
</div>
<p>参考：</p>
<p>https://github.com/johan/zsh/blob/master/Misc/compctl-examples</p>
<p>在.zshrc里加入如下语句：意思大概是自动加载fpath路径下的各种函数，比如自动补全函数。</p>
<p>fpath=(/usr/local/share/zsh-completions $fpath)<br />autoload -Uz compinit &amp;&amp; compinit -u<br />autoload -U +X bashcompinit &amp;&amp; bashcompinit</p>
<p>另外autoload/compinit/bashcompinit是zsh的builtin函数，可以使用man zshbuiltins查看帮助</p>
<h3>三、brew search comple</h3>
<p>这种模糊搜索可以查到很多工具的命令自动补全脚本：比如pip、bash、docker、zsh等</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/692500/201903/692500-20190315171921796-960499986.png" /></p>
<p>brew info bash-completion查看安装信息</p>
<h3>四、python shell的自动补全</h3>
<h3>五、zsh启动优化</h3>
<p>查看zsh启动时间：2.37s，还是很长的，是否可以优化到0.x秒，这样感觉就没有卡顿</p>
<p>time zsh -i -c exit<br />zsh -i -c exit&nbsp; 2.37s user 1.25s system 98% cpu 3.663 total</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mwdzpq.html">&period;htaccess详解及&period;htaccess参数说明【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mvmdr8.html">Yii2 前台用户与后台用户分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvyxpjq.html">使用NHibernate（8）-- 延迟加载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j01yywq.html">MSP430推荐网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xvemg9.html">bzoj3244</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdexwgx9.html">php中body下出现莫名空白字符</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mw12jq.html">【网络流24题】 No&period;3 最小路径覆盖问题 （网络流&vert;匈牙利算法 -&amp;gt&semi;最大二分匹配）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyr6d9.html">pcDuino 刷系统-LiveSuit</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnr0oq.html">C&num; WinForm窗体界面设置问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zy7j59.html">leetCode 34&period;Search for a Range &lpar;搜索范围&rpar; 解题思路和方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj1ywx9.html">B树（B-树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8medrvoq.html">ubuntu setup adb tool</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgk5278.html">WPF 设置输入只能英文</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykmom9.html">四种常用IO模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1y5vyq.html">filddler一个抓包修改的工具  貌似很强大2017&period;12&period;07</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1gpx1q.html">Python基础之数组和向量化计算总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p6we48.html">SSM框架和SSH框架的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllmlneq.html">TP5 数据库迁移工具 migrate 教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5dp74q.html">浏览器输入url回车后，会发生什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjv0mq.html">java基础应用循环的应用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90rngjj9.html">面向对象编程其实很简单&mdash;&mdash;Python 面向对象（初级篇）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1r3oe9.html">IE 浏览器 GET 请求缓存问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1wmrpq.html">Laravel Eloquent 数据查询结果中日期的格式化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjlykj9.html">pytest十：用例 a 失败，跳过测试用例 b 和 c 并标记失败 xfail</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1ry1l9.html">依赖注入与Unity</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rnw3n9.html">c3p0和QueryRunner的结合使用，让开发更加简便</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlldmekq.html">【AtCoder】CODE FESTIVAL 2017 qual C</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj6mj79.html">NDK 开发实例一（Android&period;mk环境配置下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j16zd49.html">Mq的介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw1p179.html">048 hive运行的相关配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
